/**
 * SO, 2010 - Laborator 4
 * Utilizare gdb, memcheck
 * Task 2 - linux
 */

#include <stdio.h>
#include <stdlib.h>

#define NO_FLOWERS 5

#define NAME_LEN 16

struct flower_info{
	char *name;
	int price;
	int class;
};

/*
 * allocate_flowers - aloca spatiu pentru no flori 
 * initializeaza fiecare floare cu elemente intamplatoare 
 */
struct flower_info* allocate_flowers(int no){
	int i;
	struct flower_info *f_info;

	/*TODO: alocati memorie pentru no elemente de tip flower_info */

	/* initializare */
	for(i = 0;i < no; i++){


		sprintf(f_info[i].name, "flower__%d__", i);
		f_info[i].price = 1 + i*2;
		f_info[i].class = 2 + i*3;
	}
	
	return f_info;
}
/**
 * TODO: implementati free_flowers astfel incat
 * sa dezaloce un vector de no flori
 */
void free_flowers(struct flower_info *f_info , int no){

}

void print_flowers(struct flower_info *f_info, int no){
	
	int i;
	
	for(i = 0;i < no;i++)
		printf("=%d=:Name: %s, price: %d, class: %d\n",
			i,f_info[i].name, f_info[i].price, f_info[i].class);
}

int main(void){

	struct flower_info* flowers;
		
	flowers  = allocate_flowers(NO_FLOWERS);
	if(NULL == flowers)
		return EXIT_FAILURE;
	print_flowers(flowers, NO_FLOWERS);
	
	free_flowers(flowers, NO_FLOWERS);

	return 0;
}
