/**
 * SO, 2009 - Laborator 4
 * Buffer overflow
 * Task 4 - linux
 */

#include <stdio.h>
#include <stdlib.h>

#if defined(__i386__)
  #define get_esp(esp) __asm__("movl %%esp, %0;":"=&r"(esp));
  #define get_ebp(ebp) __asm__("movl %%ebp, %0;":"=&r"(ebp));

  typedef int mytype; 

#elif defined(__x86_64)
  #define get_esp(esp) __asm__("mov %%rsp, %0;":"=&r"(esp));
  #define get_ebp(ebp) __asm__("mov %%rbp, %0;":"=&r"(ebp));

  typedef long mytype;

#else
  #error "Unknown architecture"
#endif

  
int i, size;
mytype *esp,*ebp;
mytype *p;


struct stack_element{
	mytype *address;
	mytype value;
};

/**
 * stack retine stiva , fiecare element este alcatuit din adresa
 * de pe stiva si continutul stivei de la adresa respectiva
 */
struct stack_element stack[128];

/**
 * show_snapshot, afiseaza continutul stivei in forma:
 * [adresa]: valoare
 * adaugati parameterii corespunzatori functiei printf
 */
void show_snapshot(){
	for(i = 0;i < size; i++)
		printf("[%p]:%x\n", /* TODO */);
}

/**
 * salveaza stiva cuprinsa intre ebp si esp in vectorul stack
 * inlocuiti comentariile din codul de mai jos cu valorile corespunzatoare
 */
void take_snapshot(){
	for(p = ebp; p > esp; p--){
		stack[size].address = //TODO: adresa curenta
		stack[size].value   = //TODO: valoarea de la adresa curenta
		size++;
	}
}

void show_message(void){
	printf("s0rU1lz\n");
	exit(EXIT_FAILURE);
}

/**
 * f2 , primeste 3 argumente , defineste 3 intregi
 * salveaza o vedere a stivei pentru analiza
 */
void f2(mytype x, mytype y, mytype z){
	mytype v[3];
	v[0] = 6;
	v[1] = 7;
	v[2] = 8;

	//TODO2: folositi v pentru ca la intoarcerea din f2 sa se execute functia show_message

	/* salvam stack pointer-ul curent */
	get_esp(esp);

	/* folosim esp si ebp salvati anterior */
	take_snapshot();
}

/**
 * f1 , primeste 3 argumente si apeleaza f2
 */
void f1(mytype a, mytype b, mytype c){
	f2(3,4,5);
}

/**
 * main, salveaza base pointer-ul curent, apeleaza f1
 * afiseaza o vedere a stivei anterior salvata
 */
int main(void){
	/* salvam base pointer-ul initial */
	get_ebp(ebp);
	f1(1, 2, 3);
	show_snapshot();
	return 0;
} 
